//VerrouillerAncres_501d.js
// 28.07.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Verrouiller des blocs ancrs

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// appeler la fonction qui lit les rglages enregistrs
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var rVal1   = prefVal[0];
	var rVal2   = prefVal[1];
	var pNum    = prefVal[2];
	rb01 = rb04 = 1;
	rb02 = rb03 = rb05 = 0;
	if (rVal1  == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	else if (rVal1 == "2") {
		rb01 = 0;
		rb03 = 1;
	}
	if (rVal2  == "1") {
		rb04 = 0;
		rb05 = 1;
	}
}
else {
	// lorsque le fichier des prfrences ne peut pas tre trouv, 
	// utiliser les valeurs par dfaut suivants
	rb01 =  1;
	rb02 =  0;
	rb03 =  0;
	rb04 =  1;
	rb05 =  0;
	pNum = "";
}
// appeler la fonction qui affiche le dialogue pour prendre une dcision
var userDec = askUser1();
// mettre le rsultat dans des variables
docuRge = userDec[0];
anchObj = userDec[1];

// dclencher l'action selon la dcision
if (docuRge == 0) { // "sur la planche active"
	var allFrames = app.activeWindow.activeSpread.allPageItems;
	doLock(allFrames);
}
else if (docuRge == 1) { // "dans le document entier"
	var allFrames = app.documents[0].allPageItems;
	doLock(allFrames);
}
else if (docuRge == 2) { // "dans une range de pages  dfinir"
	var pageRange = askUser2();
	// envoyer  tester la saisie
	allPages = rangeOfPages(pageRange);
	// une boucle  travers les pages
	for (var p=0; p<allPages.length; p++) {
		var allFrames = app.documents[0].pages.itemByName(allPages[p]).allPageItems;
		doLock(allFrames);
	}
}

// la liste des rglages ...
var prefsList = new Array (docuRge, anchObj, pageRange);
// ... la convertir en chane de texte ...
var prefString = prefsList.join("\n");
// ... et l'envoyer  la fonction, qui l'crit dans un fichier
writeResult(prefString);

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(1500);
// fermer la fentre
dlog.close();


////////////////////////////// les fonctions  /////////////////////////////////////////////////////

// la fonction qui prpare les informations ///////////////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/verrouiller501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/verrouiller501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le premier dialogue ///////////////////////////////////////////////////////
function askUser1() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 = 16;
	var labelWidth1 =  4;
	var labelWidth2 = 90;
	var aDialog = app.dialogs.add({name:"Verrouiller ancrs"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				staticTexts.add({staticLabel:"O est-ce qu'il faut verrouiller les blocs?"});
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons1 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"sur la planche active", checkedState:rb01});
								radiobuttonControls.add({staticLabel:"dans le document entier", checkedState:rb02});
								radiobuttonControls.add({staticLabel:"dans une range de pages  dfinir", checkedState:rb03});
							}
							staticTexts.add({staticLabel:" ", minWidth:labelWidth2});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
				staticTexts.add({staticLabel:"Verrouiller les blocs ancrs..."});
				staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							with(refButtons2 = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"si \"Empcher le positionnement manuel\" est activ", checkedState:rb04});
								radiobuttonControls.add({staticLabel:"les verrouiller tous", checkedState:rb05});
							}
						}
					}
				}
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:4});
			}
		}
	}
	if(aDialog.show() == true) {
		var refDec1 = refButtons1.selectedButton;
		var refDec2 = refButtons2.selectedButton;
		// supprimer le dialogue
		aDialog.destroy();
		// renvoyer les deux valeurs
		return [refDec1, refDec2];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// prparer et afficher le second dialogue ////////////////////////////////////////////////////////
function askUser2() {
	var fieldWidth  = 350;
	var aDialog = app.dialogs.add({name:"Verrouiller les blocs ancrs"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Entrer la range (par ex. 1, 2-3, 4-7, 8):"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var pagesField = textEditboxes.add({editContents:pNum, minWidth:fieldWidth});
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:4});
			}
		}
	}
	if(aDialog.show() == true) {
		pNum = pagesField.editContents;
		// supprimer le dialogue
		aDialog.destroy();
		// ... tester la saisie...
		if (pNum == "") {
			alert ("Range de pages:\n\nle champ texte est vide.", "Stop");
			exit();
		}
		// ... et renvoyer le rsultat
		return pNum;
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// lister les numros des pages, tester s'ils existent ////////////////////////////////////////////
function rangeOfPages(pageRange) {
	var whatKind = 0;
	var startPagesList = new Array ();
	var stopPagesList  = new Array ();
	var pagesList      = new Array ();
	// supprimer des espaces
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// vrifier si l'entre contient des virgules ou des trait-d'unions
	if (newRange.indexOf("+") != -1) {
		alert ("Des valeurs absolues  ne sont pas possibles.", "Stop");
		exit();
	}
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	// prparer les listes selon le genre de la chane
	if (whatKind == 0) {
		pagesList.push(newRange);
	}
	else if (whatKind == 1) {
		var newRangeList = newRange.split("-");
		var startVal = newRangeList[0]*1;
		var stopVal  = (newRangeList[1]*1)+1;
		for (var i=startVal; i<stopVal; i++) {
			pagesList.push(""+i);
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			pagesList.push(newRangeList[i]);
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = tmpItemList[0]*1;
				var stopVal  = (tmpItemList[1]*1)+1;
				for (var k=startVal; k<stopVal; k++) {
					pagesList.push(""+k);
				}
			}
			else {
				pagesList.push(newRangeList[i]);
			}
		}
	}
	
	// vrifier si les pages dsires existent
	var nNum = pagesList.length;
	var allPageNames = app.documents[0].pages.everyItem().name;
	for (var i=0; i<nNum; i++) {
		var okay = false;
		var actNum = pagesList[i];
		for (var k=0; k<allPageNames.length; k++) {
			if (actNum == allPageNames[k]) {
				okay = true;
				break;
			}
		}
		if (!okay) {
			alert ("La page " + actNum + " est introuvable.", "Stop");
			exit();
		}
	}
	return pagesList;
}


// die Rahmen sperren /////////////////////////////////////////////////////////////////////////////
function doLock(allFrames) {
	// une boucle  travers les pages
	for (var f=0; f<allFrames.length; f++) {
		// vrifier si le blocs est ancr
		if (allFrames[f].parent == "[object Character]") {
			// si "Empcher le positionnement manuel" est avtiv...
			if (allFrames[f].anchoredObjectSettings.lockPosition == true) {
				// si le bloce n'est pas verrouill...
				if (allFrames[f].locked == false) {
					// ... le verrouiller
					allFrames[f].locked = true;
				}
			}
			else {
				// quand tous les blocs ancrs doivent tre verrouills...
				if (anchObj == 1) {
					// activer "Empcher le positionnement manuel"
					allFrames[f].anchoredObjectSettings.lockPosition = true;
					// si le bloc n'est pas verrouill...
					if (allFrames[f].locked == false) {
						// ... le verrouiller
						allFrames[f].locked = true;
					}
				}
			}
		}
	}
}

// crire le rsultat dans un fichier /////////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/verrouiller501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/verrouiller501.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}